import Vue from 'vue'
import Router from 'vue-router'

Vue.use(Router)
import Layout from '@/layout'
export const constantRouterMap = [{
		path: '/',
		component: Layout,
		redirect: {
			name: 'login'
		}
	},
	{
		path: '/login',
		name: 'login',
		component: () => import('@/views/login/index')
	},
	{
		path: '/register',
		component: () => import('@/views/register/index')
	},
	{
		path: '/home',
		component: Layout,
		children: [{
			path: '/home',
			component: () => import('@/views/home'),
			hidden: true
		}]
	},
	{
		path: '/404',
		component: () => import('@/views/404'),
		hidden: true
	}
]
export const asyncRouterMap = [{
		path: '/contracts',
		component: Layout,
		name: 'Example',
		meta: {
			title: '合同列表',
			icon: 'el-icon-s-order',
			roles: ['admin', 'salesman', 'supplier']
		},
		redirect: {
			name: 'contracts'
		},
		children: [{
				path: 'list',
				name: 'contracts-list',
				component: () => import('@/views/contracts/list'),
				meta: {
					title: '合同列表',
					icon: 'el-icon-s-order',
					roles: ['admin', 'salesman', 'supplier']
				},
				hidden: true
			},
			{
				path: 'contracts',
				name: 'contracts',
				component: () => import('@/views/contracts/index'),
				meta: {
					title: '合同列表',
					icon: 'el-icon-s-order',
					roles: ['admin', 'salesman', 'supplier']
				}
			},
			{
				path: '/detail',
				name: 'detail',
				component: () => import('@/views/contracts/detail'),
				meta: {
					title: '合同详情',
					roles: ['admin', 'salesman', 'supplier']
				},
				hidden: true
			},
			// {
			//   path: 'contracts/addcontract',
			//   name: 'addcontract',
			//   component: () => import('@/views/contracts/addcontract'),
			//   meta: { title: '上传合同', roles: ['admin'] },
			//   hidden: true
			// },

			{
				path: 'contracts/addnewbill',
				name: 'addnewbill',
				component: () => import('@/views/contracts/addnewbill'),
				meta: {
					title: '新增汇票',
					roles: ['admin', 'salesman', 'supplier']
				},
				hidden: true
			},
			{
				path: 'contracts/billDetail',
				name: 'billDetail',
				component: () => import('@/views/contracts/billDetail'),
				meta: {
					title: '汇票详情',
					roles: ['admin', 'salesman', 'supplier']
				},
				hidden: true
			},
			{
				path: 'contracts/addcontract',
				name: 'addcontract',
				component: () => import('@/views/contracts/new_file'),
				meta: {
					title: '新增合同',
					roles: ['admin', 'salesman', 'supplier']
				},
				hidden: true
			}
		]
	},

	{
		path: '/table',
		component: Layout,
		redirect: '/table',
		name: 'Example',
		meta: {
			title: '承兑人列表',
			icon: 'el-icon-s-help',
			roles: ['admin', 'salesman', ]
		},
		children: [{
				path: 'table',
				name: 'Table',
				component: () => import('@/views/table/index'),
				meta: {
					title: '承兑人列表',
					icon: 'el-icon-s-help',
					roles: ['admin', 'salesman', ]
				}
			},
			{
				path: '/table/addAcceptor',
				name: 'Table',
				component: () => import('@/views/table/addAcceptor'),
				meta: {
					title: '新增承兑人',
					roles: ['admin', 'salesman', ]
				},
				hidden: true
			},
			{
				path: 'table/detail',
				name: 'Table',
				component: () => import('@/views/table/detail'),
				meta: {
					title: '承兑人详情',
					roles: ['admin', 'salesman', ]
				},
				hidden: true
			}
		]
	},

	{
		path: '/form',
		component: Layout,
		children: [{
				path: 'index',
				name: 'Form',
				component: () => import('@/views/form/index'),
				meta: {
					title: '出票人列表',
					icon: 'form',
					roles: ['admin', 'salesman', ]
				}
			},
			{
				path: '/form/addTicketdrawer',
				name: 'addTicketdrawer',
				component: () => import('@/views/form/addTicketdrawer'),
				meta: {
					title: '新增出票人',
					roles: ['admin', 'salesman', ]
				},
				hidden: true
			},
			{
				path: '/form/detail',
				name: 'detail',
				component: () => import('@/views/form/detail'),
				meta: {
					title: '出票人详情',
					roles: ['admin', 'salesman', ]
				},
				hidden: true
			}
		]
	},
	{
		path: '/delivery',
		component: Layout,
		children: [{
				path: 'index',
				name: 'delivery',
				component: () => import('@/views/delivery/index'),
				meta: {
					title: '供应商账号',
					icon: 'el-icon-s-promotion',
					roles: ['admin', 'salesman', ]
				}
			},
			{
				path: '/edit',
				name: 'edit',
				component: () => import('@/views/delivery/edit'),
				meta: {
					title: '编辑',
					roles: ['admin', 'salesman', ]
				},
				hidden: true
			}
		]
	},
	{
		path: '/shipments',
		component: Layout,
		children: [{
				path: '/shipments/index',
				name: 'shipments',
				component: () => import('@/views/shipments/index'),
				meta: {
					title: '报表统计',
					icon: 'el-icon-s-marketing',
					roles: ['admin', 'salesman', ]
				}
			},
			{
				path: '/shipments1',
				name: 'shipments1',
				component: () => import('@/views/shipments/shipments1'),
				meta: {
					title: '出票人分类报表',
					roles: ['admin', 'salesman', ]
				},
				hidden: true
			},
			{
				path: '/shipments2',
				name: 'shipments2',
				component: () => import('@/views/shipments/shipments2'),
				meta: {
					title: '合同统计列表',
					roles: ['admin', 'salesman', ]
				},
				hidden: true
			},
			{
				path: '/shipments3',
				name: 'shipments3',
				component: () => import('@/views/shipments/shipments3'),
				meta: {
					title: '供应商统计列表',
					roles: ['admin', 'salesman', ]
				},
				hidden: true
			}

		]
	},
	{
		path: '/management',
		component: Layout,
		children: [{
				path: 'index',
				name: 'management',
				component: () => import('@/views/management/index'),
				meta: {
					title: '业务管理员',
					icon: 'el-icon-s-management',
					roles: ['admin']
				}
			},
		]
	},
	{
		path: '/sucuirtyaudit',
		component: Layout,
		children: [{
				path: 'index',
				name: 'sucuirtyaudit',
				component: () => import('@/views/sucuirtyaudit/index'),
				meta: {
					title: '安全审计',
					icon: 'el-icon-s-check',
					roles: ['admin']
				}
			},
			{
				path: '/annexList',
				name: 'annexList',
				component: () => import('@/views/sucuirtyaudit/annexList'),
				meta: {
					title: '附件列表',
					roles: ['admin']
				},
				hidden: true
			},
			{
				path: '/logdetail',
				name: 'detail',
				component: () => import('@/views/sucuirtyaudit/detail'),
				meta: {
					title: '审计日志详情',
					roles: ['admin']
				},
				hidden: true
			}
		]
	},
	{
		path: '/databackup',
		component: Layout,
		children: [{
			path: 'index',
			name: 'databackup',
			component: () => import('@/views/databackup/index'),
			meta: {
				title: '数据备份',
				icon: 'el-icon-upload',
				roles: ['admin']
			}
		}]
	},
	{
		path: '/mine',
		component: Layout,
		children: [{
			path: 'index',
			name: 'mine',
			component: () => import('@/views/mine/index'),
			meta: {
				title: '个人资料',
				icon: 'el-icon-s-custom',
				roles: ['admin', 'salesman', 'supplier']
			}
		}]
	},

	{
		path: '*',
		redirect: '/404',
		hidden: true
	}
]

const createRouter = () => new Router({
	// mode: 'history', // require service support
	scrollBehavior: () => ({
		y: 0
	}),
	routes: constantRouterMap
})

const router = createRouter()

// Detail see: https://github.com/vuejs/vue-router/issues/1234#issuecomment-357941465
export function resetRouter() {
	const newRouter = createRouter()
	router.matcher = newRouter.matcher // reset router
}

export default router
